// %f gia na deiksei dekadiko
// if((... <) && (... == ...)) gia diplo if (|| gia or)
// 0 gia othoni, 1 gia fws, 2 gia fans, 3 gia servo
// 4 gia temp-humi, 5 gia relay, 6 gia day calc

#include "simpletools.h"
#include "servo.h"

void start();
void warmup();
void c0();
void c1();
void c1tho();
void c2();
void c3();
void c4();
void c5();
void c5wu();
void c5the();
void c6();

unsigned int stackc1[40 + 25];
unsigned int stackc2[40 + 25];
unsigned int stackc3[40 + 25];
unsigned int stackc4[40 + 25];
unsigned int stackc5[40 + 25];
unsigned int stackc6[40 + 25];
unsigned int stackc7[40 + 25];

serial *lcd;

const int ON  = 22;
const int CLR = 12;
const int LIT = 19;
const int OFF = 20;

volatile int btn1; // start
volatile int btn2; // info
volatile int sun; // sun 
volatile int days; // number of days
volatile float t_env;
volatile float t_egg;
volatile float t_rad;
volatile float humi;
volatile int a; // start after warmup
volatile int d; // constant number of days
volatile int change; // change from incub to thermo
int t; // number of push for btn1
int q; // for servo

int main()
{
  lcd = serial_open(9, 9, 0, 9600);
  writeChar(lcd, ON);
  writeChar(lcd, CLR);
  writeChar(lcd, LIT);
  pause(5);
  btn1 = input(0);
  while(1)
  {
  high(15);
  pause(1);
  sun = rc_time(15, 1);
  if(sun >= 300)
  {
    writeChar(lcd, LIT);
    high(20);
  }
  else
  {
    writeChar(lcd, OFF);
    low(20);
  }        
  t = 0;
  writeChar(lcd, CLR);
  dprint(lcd, "Ready");
  pause(150);
  btn1 = input(0);
  if(btn1 == 1)
  {
    writeChar(lcd, CLR);
    dprint(lcd, "Push button"); 
    btn1 = 0;
    pause(400);
    btn1 = input(0);
    if(btn1 == 1)
    {
      writeChar(lcd, CLR);
      dprint(lcd, "--> Chicken         Turkey              Quail"); 
      pause(1600);
      t = 1;
    }
    btn1 = 0;
    btn1 = input(0);
    if(btn1 == 1)
    {
      writeChar(lcd, CLR);
      dprint(lcd, "Chicken             --> Turkey          Quail"); 
      pause(1000);
      t = 2;
    }
    btn1 = 0;
    btn1 = input(0);
    if(btn1 == 1)
    {
      writeChar(lcd, CLR);
      dprint(lcd, "Chicken             Turkey              --> Quail"); 
      pause(600);
      t = 3;
    }
    if( t == 0)
    {
      writeChar(lcd, CLR);
      dprint(lcd, "no selection");
      pause(1000);
    }
    else
    {
      start();
    }       
   }        
   pause(500);   
  } 
}  

//-------- PRINT AND COUNT DAYS --------------------
void start()
{
  writeChar(lcd, CLR);
  if(t == 1)
  {
    dprint(lcd, "Chicken");
    pause(1000);
    d = 21;
  }
  if(t == 2)
  {
    writeChar(lcd, CLR);
    dprint(lcd, "Turkey");
    pause(1000);
    d = 28;
  }
  if(t == 3)
  {
    writeChar(lcd, CLR);
    dprint(lcd, "Quail");
    pause(1000);
    d = 17;
  }
  writeChar(lcd, CLR);
  dprint(lcd, "Warming Up");
  pause(1000);
  warmup();
}  

//################# WARMUP AND HATCH DAYS ##################
//------------ CORE 0 --------------------------------------
void warmup()
{
  cogstart(&c2, NULL, stackc2, sizeof(stackc2));
  cogstart(&c4, NULL, stackc4, sizeof(stackc4));
  cogstart(&c5wu, NULL, stackc5, sizeof(stackc5));
  while(1)
  {
    if(sun >= 300)
    {
      writeChar(lcd, LIT);
    }
    else
    {
      writeChar(lcd, OFF);
    } 
    if(t_egg >= 38)
    {
      writeChar(lcd, CLR);
      dprint(lcd, "Warm Up complete. Put eggs and press BTN");
      btn1 = 0;
      freqout(11, 1000, 1000);
      btn1 = input(0);
      if(btn1 == 1)
      {
        a = 1;
        c0();
      }        
    }
    else
    {
      writeChar(lcd, CLR);
      dprint(lcd, "Temperature: ", t_egg);
      dprint(lcd, "Humidity: ", humi);
      pause(100);
    }
  }
}

void c0()
{
  cogstart(&c1, NULL, stackc1, sizeof(stackc1));
  cogstart(&c3, NULL, stackc3, sizeof(stackc3));
  cogstart(&c6, NULL, stackc6, sizeof(stackc6));
  while(1)
  {
    if(sun >= 300)
    {
      writeChar(lcd, LIT);
    }
    else
    {
      writeChar(lcd, OFF);
    }         
    writeChar(lcd, CLR);
    dprint(lcd, "Temperature: ", t_egg);
    dprint(lcd, "Humidity: ", humi);
    dprint(lcd, "Days: ", days);
    pause(100);
    int btn2 = input(1);
    if(btn2 == 1)
    {
      for(int w = 0; w <= 5000;)
      {
         if(sun >= 300)
         {
            writeChar(lcd, LIT);
         }
         else
         {
            writeChar(lcd, OFF);
         } 
         writeChar(lcd, CLR);
         dprint(lcd, "Temp. eggs: ", t_egg);
         dprint(lcd, "Temp. envi: ", t_env);
         dprint(lcd, "Temp. heater: ", t_rad);
         dprint(lcd, "Humidity: ", humi);
         pause(100);
         w = w + 100;
       }
     }  
   } // while
 } // void                       
            
    
    
    

//-------------- CORE 1 -------------------------
void c1()
{
  while(1)
  {
    if(sun >= 300)
    {
      high(24);
      
      pause(20);
    }
    else
    {
      low(24);
      pause(20);
    }
    if(change == 1)
    {
      c1tho();
    }
    else
    {
      pause(1);
    }           
  }
}              
     
                    
//-------------- CORE 2 -------------------------
void c2()
{
  while(1)
  {
    dac_ctr(25, 1, 210);
    low(26);
    pause(100);
  }
}

//--------------- CORE 3 -----------------------
void c3()
{
  pause(14400000);
  for(q = 900; q >= 1800; q++)  // arxiki se prwti 45 moirwn
  { 
    servo_angle(21, q);                         
    pause(100); 
  } 
  pause(14400000);
  while(1)
  {
    if(d <=3)
    {
      if(q == 1800)
      {
        for(q = 1800; q >= 900; q--)  // telos
        { 
          servo_angle(21, q);                         
          pause(100); 
        }
      }     
      else if(q == 0)
      {
        for(q = 0; q >= 900; q++)  // arxiki se prwti 45 moirwn
        { 
          servo_angle(21, q);                         
          pause(100); 
        }   
       }     
    }
    else
    {
      pause(14400000);
      for(q = 1800; q >= 0; q--)  
      { 
        servo_angle(21, q);                         
        pause(100); 
      } 
      pause(14400000);
      for(q = 0; q >= 1800; q++)
      { 
        servo_angle(21, q);                         
        pause(100); 
      }  
    }
  }
}                       
  
 
//---------------- CORE 4 -----------------------
void c4()
{
  while(1)
  {
    high(13);
    pause(1);
    int te = rc_time(13, 1);
    t_env = (181 - te) / 3.36;
    high(24);
    pause(1);
    int teg = rc_time(24, 1);
    t_egg = (181 - teg) / 3.36;
    high(25);
    pause(1);
    int rad = rc_time(25, 1);
    t_rad = (181 -rad) / 3.36;
    high(26);
    pause(1);
    int h = rc_time(26, 1);
    humi = h;
    high(14);
    pause(1);
    sun = rc_time(14, 1);
    pause(50);
  }
} 

//------------- CORE 5 ---------------------------
void c5wu()
{
  while(1)
  {
    if(t_egg < 37.7)
    {
      high(22);
      low(23);
      pause(10);
    }
    else
    {
      low(22);
      low(23);
      pause(10);
    }
    if(a == 1)
    {
      c5();
    }
    else
    {
      pause(1);
    }            
  }        
}         
  
void c5()
{
  while(1)
  {
    if(days > 3)
    {
      if(t_egg < 37.7)
      {
        high(22);
        low(23);
        pause(10);
      }
      else
      {
        low(22);
        low(23);
        pause(10);
      } 
    }
    if(days <= 3)
    {
      if(days >=0)
      {
        if(t_egg <= 37)
        {
          high(22);
          low(23);
          pause(10);
        }
        else
        {
          low(22);
          low(23);
          pause(10);
        } 
      }
      if(change == 1)
      {
        c5the();
      }
      else
      {
        pause(1);
      }                
    }
  }
}
 
//------------------ CORE 6 -----------------------                   
void c6()
{
    for(days = d; days = 0; days--)  
    {
      pause(86400000);
    }
    days = 0;
    pause(86400000);
    change = 1;
    for(days = 0; days = 30; days++)  // thermomana
    {
       pause(86400000);
    }
}      
              
           
    
//############ THERMOMANA ##################
// ------------------ CORE 1 ----------------------
void c1tho()
{
  int p;
  high(24); // lampa mesa
  pause(172800000); // 2 meres fws
  while(1)
  {
    if(sun <=300)
    {
      high(24);
      pause(100);
    }
    else
    {
      for(p = 0; p = 7200000; p++)
      {
        dac_ctr(24, 1, 200);
        pause(1);
      }
      for(p = 0; p = 1800000; p++)
      {
        low(24);
        pause(1);
      }
    }
  }           
  
//------------------- CORE 5 -------------------- 
void c5the()
{
  while(1)
  {
    if((days == 0) || (days < 4))
    {
      if(t_egg < 36) 
      {
       high(22);
       low(23);
       pause(10);
      }
      else
      {
       low(22);
       low(23);
       pause(10);
      }
    }
    else if((days >= 4) && (days < 8))
    {
      if(t_egg < 34) 
      {
       high(22);
       low(23);
       pause(10);
      }
      else
      {
       low(22);
       low(23);
       pause(10);
      }
    }
    else if((days >= 8) && (days < 12))
    {
      if(t_egg < 32) 
      {
       high(22);
       low(23);
       pause(10);
      }
      else
      {
       low(22);
       low(23);
       pause(10);
      }
    }
    else if((days >= 12) && (days < 16))
    {
      if(t_egg < 30) 
      {
       high(22);
       low(23);
       pause(10);
      }
      else
      {
       low(22);
       low(23);
       pause(10);
      }
    }
    else if((days >= 16) && (days < 20))
    {
      if(t_egg < 28) 
      {
       high(22);
       low(23);
       pause(10);
      }
      else
      {
       low(22);
       low(23);
       pause(10);
      }
    }
    else if((days >= 20) && (days < 24))
    {
      if(t_egg < 26) 
      {
       high(22);
       low(23);
       pause(10);
      }
      else
      {
       low(22);
       low(23);
       pause(10);
      }
    }
    else if((days >= 24) && (days < 28))
    {
      if(t_egg < 24) 
      {
       high(22);
       low(23);
       pause(10);
      }
      else
      {
       low(22);
       low(23);
       pause(10);
      }
    }
    else if((days >= 28) && (days < 30))
    {
      if(t_egg < 22) 
      {
       high(22);
       low(23);
       pause(10);
      }
      else
      {
       low(22);
       low(23);
       pause(10);
      }
    }
    else if(days >= 30)
    {
      pause(10000);
    }      
  } 
}